﻿using System;
using System.Device.Location;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 감시자
        /// </summary>
        private GeoCoordinateWatcher watcher = null;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            #region 이벤트를 설정한다.

            Load += Form_Load;

            #endregion
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 폼 로드시 처리하기 - Form_Load(sender, e)

        /// <summary>
        /// 폼 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Form_Load(object sender, EventArgs e)
        {
            this.watcher = new GeoCoordinateWatcher();

            this.watcher.StatusChanged += watcher_StatusChanged;

            this.watcher.Start();
        }

        #endregion
        #region 감시자 상태 변경시 처리하기 - watcher_StatusChanged(sender, e)

        /// <summary>
        /// 감시자 상태 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void watcher_StatusChanged(object sender, GeoPositionStatusChangedEventArgs e)
        {
            if(e.Status == GeoPositionStatus.Ready)
            {
                if(this.watcher.Position.Location.IsUnknown)
                {
                    this.statusLabel.Text = "위치 데이터를 찾을 수 없습니다.";
                }
                else
                {
                    GeoCoordinate geoCoordinate = this.watcher.Position.Location;

                    this.latitudeTextBox.Text  = geoCoordinate.Latitude.ToString();
                    this.longitudeTextBox.Text = geoCoordinate.Longitude.ToString();
                }
            }
        }

        #endregion
    }
}